apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ errbit_name }}
  name: {{ errbit_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ errbit_replicas }}
  selector:
    name: {{ errbit_name }}
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ errbit_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ errbit_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ errbit_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ errbit_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ errbit_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
      initContainers:
      - command:
        - sh
        - -c
        - update-ca-certificates || true
        image: {{ (opsimages | json_query("[?name=='errbit'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        name: init-errbit-pki
        volumeMounts:
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: pkirun
        - mountPath: /usr/local/share/ca-certificates
          name: pkiconf
{% else %}
      initContainers: []
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: EMAIL_DELIVERY_METHOD
          value: ":smtp"
        - name: ERRBIT_ADMIN_EMAIL
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ errbit_name }}
        - name: ERRBIT_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ errbit_name }}
        - name: ERRBIT_ADMIN_USER
          value: "{{ (errbit_admin_email.split('@') | default(['admin']))[0] }}"
        - name: ERRBIT_EMAIL_FROM
          value: {{ errbit_mail_from | default('errbit@' ~ root_domain) }}
        - name: ERRBIT_HOST
          value: {{ errbit_fqdn }}
        - name: ERRBIT_PROTOCOL
          value: https
        - name: ERRBIT_USE_GRAVATAR
          value: 'true'
        - name: GITHUB_AUTHENTICATION
          value: 'false'
        - name: GOOGLE_AUTHENTICATION
          value: 'false'
        - name: MONGODB_URL
          valueFrom:
            secretKeyRef:
              key: database-url
              name: {{ ermg_name }}
        - name: PORT
          value: "8080"
        - name: RACK_ENV
          value: production
        - name: RAILS_ENV
          value: production
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ errbit_name }}
        - name: SMTP_ENABLE_STARTTLS_AUTO
          value: "true"
        - name: SMTP_HELO
          valueFrom:
            fieldRef:
              fieldPath: spec.nodeName
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: none
        - name: SMTP_PORT
{% if smtp_relay | default(False) %}
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_SERVER
          value: {{ smtp_relay }}
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: "{{ 'none' if (skip_smtp_verify | default(False)) else 'peer' }}"
{% elif smtps_address | default(False) %}
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_SERVER
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: peer
{% elif smtp_address | default(False) %}
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_SERVER
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: "none"
{% else %}
          value: ""
        - name: SMTP_SERVER
          value: ""
        - name: SMTP_OPENSSL_VERIFY_MODE
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='errbit'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='errbit'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        name: errbit
        ports:
        - containerPort: 8080
        readinessProbe:
          failureThreshold: 5
          httpGet:
            path: /health/readiness
            port: 8080
          initialDelaySeconds: 20
          periodSeconds: 10
          timeoutSeconds: 2
        resources:
          limits:
            cpu: {{ errbit_cpu_limit }}
            memory: {{ errbit_memory_limit }}
          requests:
            cpu: {{ errbit_cpu_request }}
            memory: {{ errbit_memory_request }}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
        volumeMounts:
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: pkirun
        - mountPath: /usr/local/share/ca-certificates
          name: pkiconf
{% endif %}
{% if do_lemon or do_ldap %}
      - env:
        - name: AUTH_METHOD
{% if do_lemon %}
          value: oidc
{% else %}
          value: ldap
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: OIDC_CALLBACK_URL
{% if do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: errbit
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: errbit-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ errbit_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: https://auth.{{ root_domain }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
{% if do_lemon %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
        - name: PING_PATH
          value: /ping
{% else %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=authproxy,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: authproxy-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ errbit_ldap_user_objectclass }}
{% endif %}
        - name: PING_PATH
          value: ""
{% endif %}
        - name: PROXY_BACKEND_HOST
          value: 127.0.0.1
        - name: PROXY_BACKEND_PORT
          value: "8080"
        - name: PROXY_BACKEND_PROTO
          value: http
        - name: PROXY_HTTP_PORT
          value: "8081"
        - name: PROXY_PROTO
          value: http
        - name: PROXY_SERVER_NAME
          value: {{ errbit_fqdn }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='authproxy'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='authproxy'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ errbit_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8081
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8081
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            httpHeaders:
            - name: Host
{% if do_lemon %}
              value: {{ errbit_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8081
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ authproxy_cpu_limit }}"
            memory: "{{ authproxy_memory_limit }}"
          requests:
            cpu: "{{ authproxy_cpu_request }}"
            memory: "{{ authproxy_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 8081
{% endif %}
        volumeMounts:
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
{% if do_ldap and not do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: certs
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8081/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 30
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9113
{% endif %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - stats
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ errbit_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
{% if do_ldap or do_lemon or smtps_address | default(False) %}
      volumes:
      - emptyDir: {}
        name: temp
{% if do_ldap and not do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='errbit'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - errbit
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='errbit'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
{% if (do_lemon or do_ldap) and (opsimages | json_query("[?name=='authproxy'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - authproxy
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='authproxy'].short"))[0] }}
        namespace: {{ buildns }}
{% if do_exporters and (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
  - type: ConfigChange
{% endif %}
